<?php
namespace Fiscal\Logic\Relatorios;

use \Fiscal\Entities\Mapaapurac;

class DocArrecadacao{

    public static function SelectMapaapurac($checks) {
        try {
            $nmmapas = array();
            foreach ($checks as $item){
                $nrsequmapapu = $item['NRSEQUMAPAPU'];
                $nrorg = $item['NRORG'];
                $nmmapaapur = $item['NMMAPAAPUR'];

                /* Pesquisa se o mapa est sem data de vencimento e valor total */
                /** @var $mapaapurac Mapaapurac */
                $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
                $dtvencmapa = $mapaapurac->getDtvencmapa();
                $vrtotaguia = $mapaapurac->getVrtotaguia();
                /* Caso esteja vazio, adiciona o nome do mapa a um vetor para imprimir na tela para o usurio */
                if (($dtvencmapa == null) or ($vrtotaguia == null)){
                    $nmmapas[] = $nmmapaapur;
                }
                /* Caso esteja ok, armazena-se os dados para serem passados como parametros na emissao do relatorio */
                else{
                    $DadosEmissao[] = array(
                        
                            "NRSEQUMAPAPU" => $nrsequmapapu,
                               "CDIMPOSTO" => $item['CDIMPOSTO'],
                               "CDEMPRESA" => $item['CDEMPRESA'],
                              "CDINSCESTA" => $item['CDINSCESTA']
                         
                    );                
                }
            }
            /* conta quantos mapas est sem data de vencimento e valor total */
            
            $mapa = "";
            $cont = count($nmmapas);
            if ($cont > 0){
                for ($x=0; $x < $cont; $x++){
                    $mapa = $mapa.", ".$nmmapas[$x];
                }
                $msg1 = "O(s) mapa(s)";
                $msg2 = " esta(ao) sem data de vencimento ou valor total da guia.";
                $msgFinal = $msg1.$mapa.",".$msg2;
                tk_abort($msgFinal);
            }
            else{
                /* default p/ teste */
                $relatorio = "FIS00601";
                self::abreRelatorio($relatorio, $DadosEmissao);
            }
        } catch (\Exception $e) {
            \Geral\Util\TratamentoDeMensagens::exibirMensagens($e);
        }

    }
    
    public static function abreRelatorio($relatorio, $DadosEmissao) {
        try {
            foreach ($DadosEmissao as $item){
                $nrsequmapapu = $item['NRSEQUMAPAPU'];
                $cdimposto = $item['CDIMPOSTO'];
                $cdempresa = $item['CDEMPRESA'];
                $cdinscesta = $item['CDINSCESTA'];
                $params = array(
                    "P_NRSEQUMAPAPU" => $nrsequmapapu,
                    "P_CDIMPOSTO" => $cdimposto,
                    "P_CDEMPRESA" => $cdempresa,
                    "P_INSCRICAO" => $cdinscesta,
                );
                tk_open_qr2_report_from_array($relatorio, $params, "Guia de Arrecadacao Estadual.pdf");
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
}
