/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLAP                                                     */
/* Tabela : CLATERAP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 08/01/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CLAT
BEFORE INSERT OR UPDATE OR DELETE
ON CLATERAP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCLAT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCLATERAP,0) <> NVL(:NEW.CDCLATERAP,0)) OR
         (NVL(:OLD.NMCLATERAP,0) <> NVL(:NEW.NMCLATERAP,0)) THEN
         :NEW.DTULTATUCLAT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CLATERAP', '', 'CDCLATERAP='||:OLD.CDCLATERAP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CLATERAP MODIFY DTULTATUCLAT DEFAULT SYSDATE
/
