CREATE OR REPLACE FUNCTION BUSCA_ALIQ_CRED_PRES(
   P_CDEMPRESA    IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDTIPOOPER   IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_CDCLASFISC   IN CLASFISCAL.CDCLASFISC%TYPE,
   P_CDCFOPPADRAO IN CFOPPADRAO.CDCFOPPADRAO%TYPE) RETURN NUMBER
AS
   V_VRALIQUOTA       IMPOSTONF.VRALIQNF%TYPE;
   V_IDAPURLUCPRE     INSCRESTAD.IDAPURLUCPRE%TYPE;
   V_CDTIPOPERCREDP   INSCRESTAD.CDTIPOPERCREDP%TYPE;
   V_VRALIQTOTALSAIDA INSCRESTAD.VRALIQTOTALSAIDA%TYPE;
BEGIN
   V_VRALIQUOTA := 0;

   BEGIN
      SELECT IDAPURLUCPRE, CDTIPOPERCREDP, VRALIQTOTALSAIDA
        INTO V_IDAPURLUCPRE, V_CDTIPOPERCREDP, V_VRALIQTOTALSAIDA
        FROM INSCRESTAD
       WHERE CDEMPRESA = P_CDEMPRESA
         AND CDINSCESTA = P_CDINSCESTA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDAPURLUCPRE    := 'N';
         V_CDTIPOPERCREDP   := '';
         V_VRALIQTOTALSAIDA := 0;
   END;

   /*Se os parmetros enviados no entram nas condies necessrias para o regime de crdito presumido,
     retorna 0 como alquota de presuno*/
   IF (V_IDAPURLUCPRE = 'N') OR  (V_VRALIQTOTALSAIDA = 0) OR
      NOT ((V_CDTIPOPERCREDP IS NULL) OR (INSTR(V_CDTIPOPERCREDP, '_' ||'S'||P_CDTIPOOPER||'_' ) > 0)) THEN
      V_VRALIQUOTA := 0;
   ELSE
      BEGIN
         SELECT VRALIQUOTA
           INTO V_VRALIQUOTA
           FROM CREDPRESNCM
          WHERE CDEMPRESA  = P_CDEMPRESA
            AND CDINSCESTA = P_CDINSCESTA
            AND CDCLASFISC = P_CDCLASFISC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRALIQUOTA := 0;
      END;
      IF V_VRALIQUOTA = 0 THEN
         BEGIN
            SELECT VRALIQUOTA
              INTO V_VRALIQUOTA
              FROM CREDPRESCFOP
             WHERE CDEMPRESA    = P_CDEMPRESA
               AND CDINSCESTA   = P_CDINSCESTA
               AND CDCFOPPADRAO = P_CDCFOPPADRAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRALIQUOTA := 0;
         END;
      END IF;
      IF V_VRALIQUOTA = 0 THEN
         V_VRALIQUOTA := V_VRALIQTOTALSAIDA;
      END IF;
   END IF;
   RETURN V_VRALIQUOTA;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_ALIQ_CRED_PRES','6.05.xxx'); END;
/

