function Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller(General, ScreenService, templateManager, localStorageEngine, Utilities, MessageService) {
    
    var dayOfWeek = null;
    
    this.setWeekDay = function(field, widget){
    
         dayOfWeek = moment(field.value(), "DD/MM/YYYY").weekday();
    
        switch(dayOfWeek) {
            case 0:
                dayOfWeek = ScreenService.i18n('Domingo');
                break;
            case 1:
                dayOfWeek = ScreenService.i18n('Segunda-Feira');
                break;
            case 2:
                dayOfWeek = ScreenService.i18n('Terça-Feira');
                break;
            case 3:
                dayOfWeek = ScreenService.i18n('Quarta-Feira');
                break;
            case 4:
                dayOfWeek = ScreenService.i18n('Quinta-Feira');
                break;
            case 5:
                dayOfWeek = ScreenService.i18n('Sexta-Feira');
                break;
            case 6:
                dayOfWeek = ScreenService.i18n('Sábado');
                break;
            default:
                dayOfWeek = '';
        }
        
        if(field.name === 'DTINI'){
            widget.currentRow.SEMANAINI = dayOfWeek;
        }
        else if(field.name ==='DTFIN'){
            widget.currentRow.SEMANAFIM = dayOfWeek;
        }
       
    };
    
    this.setDefaultWeekDay = function(){
    
        dayOfWeek = moment().weekday();
    
        switch(dayOfWeek) {
            case 0:
                dayOfWeek = ScreenService.i18n('Domingo');
                break;
            case 1:
                dayOfWeek = ScreenService.i18n('Segunda-Feira');
                break;
            case 2:
                dayOfWeek = ScreenService.i18n('Terça-Feira');
                break;
            case 3:
                dayOfWeek = ScreenService.i18n('Quarta-Feira');
                break;
            case 4:
                dayOfWeek = ScreenService.i18n('Quinta-Feira');
                break;
            case 5:
                dayOfWeek = ScreenService.i18n('Sexta-Feira');
                break;
            case 6:
                dayOfWeek = ScreenService.i18n('Sábado');
                break;
            default:
                dayOfWeek = '';
        }
        
        return dayOfWeek;
    };
    
    this.createDsFilterOperador = function (field) {
        
			field.dataSourceFilter = [
				{
					'name' : 'CDFILIAL',
					'operator': '=',
					'value': 'FILIAL_LOGADA'
				},
				{
                    "operator": "ORDER_BY",
                    "name": [
                        {
                            "name": "CDOPERADOR",
                            "direction": "ASC"
                        }
                    ]
                }
			];
    };
    
    this.createDsFilter = function (field) {
        field.dataSourceFilter = [
			{
				'name' : 'P_CDFILDEST',
				'operator': '=',
				'value': getLocalVar('CDFILIAL')
			}
		];
		
		field.reload();
	};
	
    this.validaData = function(widget) {
        var dataInicial = widget.currentRow.DTINI ? moment(widget.currentRow.DTINI, 'DD/MM/YYYY')._d : null;
        var dataFinal = widget.currentRow.DTFIN ? moment(widget.currentRow.DTFIN, 'DD/MM/YYYY')._d : null;

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            widget.currentRow.DTFIN = widget.currentRow.DTINI;
         
            return false;
        }
            
        return true;
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    };
    
    this.readOnlyProduto = function(widget) {
        if(!widget.currentRow.CDPRODINI && !widget.currentRow.CDPRODFIN) {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        } else {
            widget.getField('NMPRODINI').validations = {"required": true};
            widget.getField('NMPRODFIN').validations = {"required": true};
        }
    };
    
    this.productControl = function(field, widget){
        if(!(this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN))){
            if(field.name == 'NMPRODINI'){
                widget.currentRow.CDPRODINI = '';
                widget.currentRow.NMPRODINI = '';
            }else{
                widget.currentRow.CDPRODFIN = '';
                widget.currentRow.NMPRODFIN = '';
            }
        }
    };
    
    this.onEnterFiltro = function(widget) {
        var filterRow = {};
        filterRow.DTINI = moment().format('L');
        filterRow.DTFIN = moment().format('L');
        widget.getField('DTINI').defaultValue = moment().format('L');
        widget.getField('DTFIN').defaultValue = moment().format('L');
        widget.applyDefaultValue();
        this.setWeekDay(widget.getField('DTINI'), widget);
        this.setWeekDay(widget.getField('DTFIN'), widget);
        filterRow.SEMANAINI = widget.currentRow.SEMANAINI;
        filterRow.SEMANAFIM = widget.currentRow.SEMANAFIM;
        Utilities.startFilter(widget, filterRow);
    };
    
    this.setCustomFilterRow = function(args){
        delete args.e.preference.FILTER_ROW.NMPRODFIN;
        delete args.e.preference.FILTER_ROW.SEMANAFIM;
        delete args.e.preference.FILTER_ROW.SEMANAINI;
    };
    
    this.limpaFieldUnidades = function(widget) {
        widget.currentRow.CDFILDEST = '';
    };
    
    this.filtrar = function(args){
        var row = args.e.preference.FILTER_ROW;
        if(args.owner.isValid() && this.validaData(args.owner)) {
            var CDGRUPFILI  = row.CDAGRUPFILI ? row.CDAGRUPFILI : null;
            var CDFILIAL    = row.CDFILDEST ? Array.isArray(row.CDFILDEST) && row.CDFILDEST.length > 0 ? row.CDFILDEST.join('_') : 'T' : 'T';
            var CDOPERADOR  = row.CDOPERADOR == undefined || row.CDOPERADOR.length === 0  ? 'T' : row.CDOPERADOR.join('_');
            var CDOPERAPROV = row.CDOPERAPROV == undefined || row.CDOPERAPROV.length === 0  ? 'T' : row.CDOPERAPROV.join('_');
            var NRAUTOFORN  = row.NRAUTOFORN == undefined || row.NRAUTOFORN.length === 0  ? 'T' : row.NRAUTOFORN.join('_');
            var CDPRODINI   = row.CDPRODINI ? row.CDPRODINI : '0';
            var CDPRODFIN   = row.CDPRODFIN ? preencheCaracterDireta(row.CDPRODFIN) : 'Z'.padEnd(20,'Z');
            
            args.owner.dataSourceFilter = [
                { "name": "P_CDAGRUPFILI", "operator": "=", "value": CDGRUPFILI },
                { "name": "L_CDFILDEST", "operator": "=", "value": CDFILIAL },
                { "name": "P_PRODINI",  "operator": "=", "value": CDPRODINI },
                { "name": "P_PRODFIN",  "operator": "=", "value": CDPRODFIN },
                { "name": "P_DTINI", "operator": "=", "value": row.DTINI },
                { "name": "P_DTFIN", "operator": "=", "value": row.DTFIN },
                { "name": "L_CDOPERADOR", "operator": "=", "value": CDOPERAPROV },
                { "name": "L_CDCOMPRADOR", "operator": "=", "value": CDOPERADOR },
                { "name": "L_AUTOFORNE", "operator": "=", "value": NRAUTOFORN }
            ];

            this.setStripeValues(args.owner);
            ScreenService.closePopup();
            args.owner.reload();

        }

    };
    
    this.concatenaAutoFornec = function(widget) {
        
        var data = widget.dataSource.data;
        var IDTIPOLANC;
        
        data.forEach(function(row){
            if(row.IDTIPOLANCAF == 'M') {
                IDTIPOLANC = "Manual";
            }
            else {
                IDTIPOLANC = "Automática";
            }
            var autofornec = row.NRAUTOFORN + ' / ' + row.CDFILLANC + ' -- ' + IDTIPOLANC + ' -- ' + 'Data: ' + moment(row.DTAUTOFORN,'DD/MM/YYYY').format("DD/MM/YYYY"); 
            row.NRAUTOFORN = autofornec;
        });  
    
        
    };
    
    this.setStripeValues = function (widget) {
		var stripe = templateManager.container.getWidget('stripe');
		stripe.currentRow.PERIODO	= widget.appliedFilter.FILTER_ROW.DTINI + " a " + widget.appliedFilter.FILTER_ROW.DTFIN;

	};
	
    function preencheCaracterDireta (string){
        return string.padEnd(20,'Z');
    }
    
    this.fechaSwipe = function(widget){
        ScreenService.closeSwipe();
        widget.activate();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller', Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller);
});